<div id="@file_tree_id@" style="height: 600px; overflow: hidden; -webkit-user-select: none; -moz-user-select: none; -khtml-user-select: none; -ms-user-select: none; "></div>

<script type='text/javascript'>
Ext.Loader.setPath('PO', '/sencha-core');
Ext.Loader.setPath('FileStorage', '/intranet-rest-fs-openacs');
// Disable the ?_dc=123456789 parameter from loader
Ext.Loader.setConfig({disableCaching: false});

Ext.require([
    'Ext.data.*',
    'Ext.grid.*',
    'Ext.tree.*',
    'Ext.panel.*',
    'PO.Utilities',
    'PO.controller.StoreLoadCoordinator',
    'FileStorage.File',
    'FileStorage.FileTreeStore',
    'FileStorage.FileTreePanel',
    'FileStorage.FileTreePanelController'
]);

/**
 * Launch the display
 */
function launchFileTree(debug){

    var fileTreeStore = Ext.StoreManager.get('fileTreeStore');
    var renderDiv = Ext.get("@file_tree_id@");
    var gifPath = "/intranet/images/navbar_default/";

    // Left-hand side file tree
    var fileTreePanel = Ext.create('FileStorage.FileTreePanel', {
        id: 'fileTreePanel',
        debug: debug,
        width: 600,
        height: 300,
	renderTo: renderDiv,
        store: fileTreeStore,
        tbar: [
            { icon: gifPath+'add.png', tooltip: 'Add a new task', id: 'buttonAddFile', 
	      handler: function() { 
		  var folderId = @folder_id@+0;    // ToDo: Replace with selection model
                  var url = '/file-storage/file-add?folder_id='+folderId;
                  window.open(url);                       // Open project in new browser tab
	      }}, 
            { icon: gifPath+'folder_add.png', tooltip: 'Reduce Indent', id: 'buttonAddFolder'},
            { icon: gifPath+'delete.png', tooltip: 'Delete a task', id: 'buttonDelete'},
            { xtype: 'tbseparator' }
        ]
    }).show();


    var fileTreePanelController = Ext.create('FileStorage.FileTreePanelController', {
        fileTreePanel: fileTreePanel,
        debug: debug
    });
    fileTreePanelController.init(this);


xxx;


};


/**
 * onReady() - Launch the application
 * Uses StoreCoordinator to load essential data
 * before calling launchFileTree() to start the
 * actual applicaiton.
 */
Ext.onReady(function() {
    Ext.QuickTips.init();							// No idea why this is necessary, but it is...
    Ext.getDoc().on('contextmenu', function(ev) { ev.preventDefault(); });      // Disable Right-click context menu on browser background
    var debug = false;

    /* ***********************************************************************
     * 
     *********************************************************************** */

    var fileTreeStore = Ext.create('FileStorage.FileTreeStore');

    // Store Coodinator starts app after all stores have been loaded:
    var coordinator = Ext.create('PO.controller.StoreLoadCoordinator', {
        debug: debug,
        stores: [
            'fileTreeStore'
        ],
        listeners: {
            load: function() {
                if ("boolean" == typeof this.loadedP) { return; }		// Check if the application was launched before
                launchFileTree(debug);					// Launch the actual application.
                this.loadedP = true;						// Mark the application as launched
            }
        }
    });

    // Load store that need parameters
    fileTreeStore.getProxy().extraParams = { object_id: @object_id@ };
    fileTreeStore.load({
        callback: function(records, operation, success) {
            var me = this;
            if (debug) console.log('FileStorage.FileTreeStore: loaded');
	    if (!success) {
		PO.Utilities.reportStoreError("FileTreeStore", operation);
		return;
	    }

	    var mainNode = records[0];
	    me.setRootNode(mainNode);
        }
    });
   
});
</script>
