
/*
 * Data related to a project.
 *
 * Only the fields required by this application are specified here.
 */

Ext.define('POSync.model.Project', {
    extend:     'Ext.data.Model',
    idProperty: 'project_id',
    
    fields: [
        'id',
        'project_id',                           // The primary key or object_id of the project
        'project_name',                         // The name of the project

        'creation_user',                        // User_id of the guy creating the project
        'project_nr',                           // The short name of the project.
        'project_path',                         // The short name of the project.
        'project_wbs',                          // WBS code
        'parent_id',                            // The parent of the project or NULL for a main project
        'tree_sortkey',                         // A strange bitstring that determines the hierarchical position
        'company_id',                           // Company for whom the project has been created

        'project_status_id',                    // 76=open, 81=closed, ...
        'project_type_id',                      // 100=Task, 101=Ticket, 2501=Gantt Project, ...

        'start_date',                           // '2001-01-01 00:00:00+01'
        'end_date',
        'project_lead_id',                      // Project manager
        'percent_completed',                    // 0 - 100: Defines what has already been done.
        'description',
        'note',
        {   /* used to display in selection boxes */
            name: 'full_name',
            convert: function (value, record) {
                return record.get('project_nr') + ' - ' + record.get('project_name');
            }
        }        
    ]
});
