
/*
 * DataStore for projects.
 *
 * This is a read-only store.
 * Proxy URL depends on application's configuration settings.
 */

Ext.define('POSync.store.Projects', {
    storeId:            'Projects',
    extend:             'Ext.data.Store',
    model:              'POSync.model.Project',

    autoLoad:           false,                          // Allow the application to set extraParams
    remoteFilter:       true,                           // Do not filter on the Sencha side
    pageSize:           100000,                         // Load all projects, no matter what size(?)
    
    isLoaded:             false,
    
    proxy: {
        type:           'rest',                         // Standard ]po[ REST interface for loading
        url:            '/intranet-rest/im_project',
        appendId:       true,
        timeout:        300000,
        extraParams: {
            format:             'json',
            query:              'parent_id is NULL'     // Select only top-level projects
            // deref_p:         '1'                     // We don't need company_name etc.
            // This should be overwrittten during load.
        },
        reader: {
            type:               'json',                 // Tell the Proxy Reader to parse JSON
            root:               'data',                 // Where do the data start in the JSON file?
            totalProperty:      'total'                 // Total number of tickets for pagination
        },
        writer: {
            type:               'json'                  // Allow Sencha to write ticket changes
        }
    }
});


