// /sencha-core/www/model/file/File.js
//
// Copyright (C) 2013 ]project-open[
//
// All rights reserved. Please see
// http://www.project-open.com/license/ for details.

/**
 A "File" represents a content item in the database.
 Files are stored in content folders.
 Content folders can be associated with a project via
 acs_rel.
**/

Ext.define('FileStorage.File', {
    extend: 'Ext.data.Model',
    xtype: 'file',
    fields: [
        // Identity
        'id',					// The system wide unique ID for this object (-> cr_items.item_id)
        'name',					// The name of the task (inherited from File)
        'version_id',				// The active version of the file (-> cr_revisions.revision_id)
        'description',				// Description of the task activity
	'title',				// title
        'iconCls',                              // Used by ExtJS for the icon, seems to work
	'content_length',			//
	'sha1',					// sha-1 Hash of the content
        'expanded',                             // true or false (without quotes), default state for tree
	'type',					// folder or mime-type
	'leaf',					// leaf or has sub-elements?

        {   name: 'icon',			// A &nbsp; sequence representing the file indentation
            convert: function(value, record) {
                var type = record.get('type');
		console.log('PO.model.file.File.icon: Type='+type);
                switch (type) {
                case 101: return '/intranet/images/navbar_default/tag_blue.png'; break;		// Ticket
                case 2502: return '/intranet/images/navbar_default/table.png'; break;		// SLA
                default: return '';		// Empty string - enables default behavior
                }
            }
        },
        {   name: 'indent',			// A &nbsp; sequence representing the file indentation
            convert: function(value, record) {
                var level = record.get('level');
                var result = '';
                while (level > 0) {
                    result = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + result;
                    level = level - 1;
                }
                return result;
            }
        }
    ]
});

