/*
 * FileTreePanel.js
 *
 * Copyright (c) 2011 - 2018 ]project-open[ Business Solutions, S.L.
 * This file may be used under the terms of the GNU General Public
 * License version 3.0 or alternatively unter the terms of the ]po[
 * FL or CL license as specified in www.project-open.com/en/license.
 */


/**
 * TreePanel with the list of files.
 */
Ext.define('FileStorage.FileTreePanel', {
    extend:				'Ext.tree.Panel',
    alias:				'fileTreePanel',
    animate:				false,				// Animation messes up bars on the right side
    collapsible:			false,
    multiSelect:			true,
    rootVisible:			false,
    singleExpand:			false,
    shrinkWrap:				false,
    title:				false,
    useArrows:				true,

    // Scrolling
    overflowX: 'scroll',						// Allows for horizontal scrolling, but not vertical...
    scrollFlags: {x: true},						// ... vertical scrolling is handled by the FileTree
    
    // the 'columns' property is now 'headers'
    columns: [

        {text: 'Download',
          xtype: 'actioncolumn',
          dataIndex: 'id',
          width: 50,
          items: [{
              icon: '/intranet/images/external.png',
              tooltip: 'Link',
              handler: function(grid, rowIndex, colIndex) {
                  var rec = grid.getStore().getAt(rowIndex);
                  var url = '/intranet-rest-fs-openacs/download?file_id='+rec.get('id');
                  window.open(url);                       // Open project in new browser tab
              }
          }]
        },

        {text: 'Description', stateId: 'treegrid-description', flex: 1, hidden: true, dataIndex: 'description'},
        {text: 'File', stateId: 'treegrid-File', xtype: 'treecolumn', flex: 2, sortable: false, dataIndex: 'name', 
         editor: true, 
         renderer: function(v, context, model, d, e) {
            context.style = 'cursor: pointer;'; 
            var children = model.childNodes;
            if (0 == children.length) { return model.get('name'); } else { return "<b>"+model.get('name')+"</b>"; }
        }},
        {text: 'Description', stateId: 'treegrid-description', flex: 1, hidden: true, dataIndex: 'description', editor: {allowBlank: true}}
    ],

    initComponent: function() {
        var me = this;
        if (me.debug) console.log('FileStorage.FileTreePanel.initComponent: Starting');
        this.callParent(arguments);
        if (me.debug) console.log('FileStorage.FileTreePanel.initComponent: Finished');
    }

});

