ad_page_contract {
    page to add a new file to the system

    @author Kevin Scaldeferri (kevin@arsdigita.com)
    @creation-date 6 Nov 2000
    @cvs-id $Id$
} {
    { project_id:integer "" }
    { path ""}
}

set user_id [ad_conn user_id]
set package_id [ad_conn package_id]
set package_id [db_string package "select min(package_id) from apm_packages where package_key = 'file-storage'" -default $package_id]
ns_log Notice "mkdir: path=$path, project_id=$project_id"

if {"" ne $project_id} {
    set folder_id [im_rest_fs_folder_for_object -object_id $project_id]
}

set file_id [db_nextval "acs_object_id_seq"]


set path_pieces [split $path "/"]
set parent_pieces [lrange $path_pieces 0 end-1]
set folder_name [lindex $path_pieces end]
ns_log Notice "mkdir: path=$path, parent_pieces=$parent_pieces, folder_name=$folder_name"

set parent_id [im_rest_fs_folder_for_path -object_id $project_id -path [join $parent_pieces "/"]]
if {"" eq $parent_id} {
    doc_return 500 "text/plain" "Did not find path=$path for object_id=$object_id"
    ad_script_abort
}

set folder_id [fs::new_folder \
    -name $folder_name \
    -pretty_name $folder_name \
    -parent_id $parent_id \
    -creation_user $user_id \
    -creation_ip [ad_conn peeraddr] \
    -package_id $package_id \
]

db_string reg "select content_folder__register_content_type(:folder_id, 'content_folder', true)"
db_string reg "select content_folder__register_content_type(:folder_id, 'file_storage_object', true)"
db_string reg "select content_folder__register_content_type(:folder_id, 'content_extlink', true)"


doc_return 200 "text/plain" "project_id=$project_id, path=$path"
ad_script_abort

