# /packages/intranet-rest-fs-openacs/www/file-tree.json.tcl
#
# Copyright (C) 2013-2018 ]project-open[

ad_page_contract {
    Returns a JSON tree structure suitable for batch-loading a project TreeStore
    @param object_id ]po[ Business Object to which the FS belongs. 
           0 identifies the global "Home" FS
    @author frank.bergmann@project-open.com
    
    @param node Passed by ExtJS to load sub-trees of a tree.
                Normally not used, just in case of error.
} {
}

set user_id [auth::require_login]

set query {
    select
        project_id,
        project_nr,
        project_name
    from
        acs_rels r,
        im_projects p
    where
        p.parent_id is null
        and r.object_id_one = p.project_id
        and r.object_id_two = :user_id
}

set json_projects [list]
db_foreach projects_list $query {
    lappend json_projects [util::json::object::create [list \
        project_id $project_id \
        project_nr $project_nr \
        project_name $project_name \
        expanded false \
        leaf true \
    ]]
}

set json_string [util::json::gen [util::json::object::create [list \
    success true \
    children [util::json::array::create $json_projects] \
]]]

doc_return 200 "application/json" $json_string

# vi:set expandtab shiftwidth=4 softtabstop=4 :
